#include "util.h"

#define CONFIG_FILE "/usr/local/etc/ipaccounting.xml"
//#define CONFIG_FILE "/root/ipac/test/ipaccounting.xml"

#define DATA_XML 1
#define DATA_TEXT 2
#define DATA_BINARY 3
#define DATA_RRD 4

#define INPUT_ARP 1
#define INPUT_LBCFREE 2
#define INPUT_LIST 3
#define INPUT_END 0

#define DEVICES 20
#define DEVNAME_SIZE 10
#define MAX_INPUTS 5

class Config
{
  struct input {
    unsigned type;
    char name[MAX_LINELEN];
  };

public:
  char IpTables[MAX_LINELEN];
  char RrdTool[MAX_LINELEN];
  char DataDir[MAX_LINELEN];
  char DeviceList[DEVICES][DEVNAME_SIZE];
  unsigned char DeviceNum;
  char DataFileName[MAX_LINELEN];
  char OldDataFileName[MAX_LINELEN];
  int DataFormat;
  int OldDataFormat;
  char HTMLTemplate[MAX_LINELEN];
  int WWWRefresh;
  char GraphScriptURL[MAX_LINELEN];
  bool TestRun;
  bool Debug;
  struct input Input[MAX_INPUTS];
  unsigned InputNum;
  bool RemoveUnlistedAddresses;
  bool DeleteRRDs;
  
  Config();
  bool setIpTablesLocation(const char *location);
  bool setRrdToolLocation(const char *location);
  bool setDataDirLocation(const char *location);
  bool addInputType(const char *type);
  bool addInputName(const char *name);
  bool addDevice(const char *device);
  bool setDataFileName(const char *name);
  bool setOldDataFileName(const char *name);
  bool setDataFormat(const char *format);
  bool setOldDataFormat(const char *format);
  bool setHTMLTemplate(const char *name);
  bool setWWWRefresh(const char *refresh);
  bool setGraphScriptURL(const char *url);
  bool setRemoveUnlistedAddresses(const char *value);
  bool setDeleteRRDs(const char *value);
  
  void Print();
  int Read(char* file);

private:
  int parseDataFormat(const char *format);
};
