#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "data.h"
#include "iplist.h"
#include "util.h"

bool IPList::Read(TrafficData* data, char* filename)
{
  char *s = NULL;
  size_t len = 0;
  FILE *f = fopen(filename, "rt");
  if (!f)
  {
    fprintf(stderr, "Nelze otevrit %s: %s\n", filename,
            strerror(errno));
    return false;
  }
                                                                                
  unsigned ip;
  char *s1, *s2, s_end;
  
  while (getline(&s, &len, f) != -1)
  {
    s1 = s;
    while(*s1)
    {
      while(*s1 && !isdigit(*s1)) s1++;
      if(!*s1)
        break;

      s2=s1;
    
      while(*s2 && (isdigit(*s2) || *s2 == '.'))
        s2++;

      s_end = *s2;
      *s2=0;

      ip = parse_ip(s1);
      if(ip == 0)
      {
	fprintf(stderr, "Can't parse ip: %s in file %s\n", s1, filename);
      }
      
      data->addFlags(ip, F_LIST);
       
      if(s_end == 0)
        break;
      s1 = s2+1;
    }
  }

  if(s)
    free(s);

  fclose(f);

  return true;
}

