#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

#include "data.h"
#include "lbcfreelist.h"
#include "util.h"

int LbcFreeList::parseLine(char *s, unsigned *id, unsigned *ip, char* name)
{
  char *t;

  t = strchr(s, '#'); //odstran komentare
  if(t) *t=0;
  
  t = strchr(s, ',');            //1 sloupec id
  if (!t)
    return 1; //prazdny radek
  *t = 0;
  *id = atoi(s);
  if (!*id)
    return 0;

  s = t+1;
  t = strchr(s, ',');            //2 sloupec nazev
  if(!t)
    return 0;
  strcpy(name, s);  

  s = t+1;
  t = strchr(s, ',');            //3 sloupec ip
  if (!t)
    return 0;
  *t = 0;
  *ip = parse_ip(s);
  if (!*ip)
    return 0;

/*  s = t+1;
  t = strchr(s, ',');           //4 sloupec MAC adresa
  if (!t)
    return 0;

  s = t+1; 			//5 sloupec rate
*/

  return 1;
}

int LbcFreeList::Read(TrafficData * data, char* filename)
{
  char *s = NULL;
  size_t len = 0;

  FILE *f = fopen(filename, "rt");
  if (!f)
  {
    fprintf(stderr, "Nelze otevrit %s: %s\n", filename, strerror(errno));
    return -1;
  }

  unsigned id;
  unsigned ip;
  char name[MAX_LINELEN];
  unsigned line=0;

  while (getline(&s, &len, f) != -1)
  {
    line++;
    if (parseLine(s, &id, &ip, name))
    {
      data->addFlags(ip, F_LBCFREE);
    }
    else
    {
      fprintf(stderr, "Chyba v LbcFree souboru %s radek %u.\n", filename, line);
    }
  }

  if (s)
    free(s);

  fclose(f);
  return 0;
}
