#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

#include "util.h"

char *string_ip(unsigned ip)
{
  static char s[MAX_LINELEN];
  sprintf(s, "%d.%d.%d.%d", (ip & 0xFF000000) >> 24, (ip & 0x00FF0000) >> 16,
          (ip & 0x0000FF00) >> 8, (ip & 0x000000FF));
  return s;
}

char *skip_token(char *s)
{
  while (*s != 0 && isgraph(*s))
    s++;
  return s;
}

unsigned parse_ip(char *s)
{
  unsigned ip = 0;
  s = strtok(s, ".");
  if (!s)
    return 0;
  ip = atoi(s) << 24;

  s = strtok(NULL, ".");
  if (!s)
    return 0;
  ip += atoi(s) << 16;

  s = strtok(NULL, ".");
  if (!s)
    return 0;
  ip += atoi(s) << 8;

  s = strtok(NULL, "./");
  if (!s)
    return 0;
  ip += atoi(s);

  return ip;
}

char *skip_whitespace(char *s)
{
  while (*s != 0 && isspace(*s))
    s++;
  return s;
}
